;--- Settings ---------------------------------------------------------

dump_tmc_settings:
;---------------------------------------------
		load_p		Z,(set_id<<1)
		rcall		uart_fsend
		ldi			r16,7
		ldi			r17,50
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_rs<<1)
		rcall		uart_fsend
		ldi			r16,6
		ldi			r17,5
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_chopconf<<1)
		rcall		uart_fsend
		ldi			r16,0
		ldi			r17,6
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_sgcsconf<<1)
		rcall		uart_fsend
		ldi			r16,1
		ldi			r17,6
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_drvconf<<1)
		rcall		uart_fsend
		ldi			r16,2
		ldi			r17,6
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_drvctrl<<1)
		rcall		uart_fsend
		ldi			r16,3
		ldi			r17,6
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_smarten<<1)
		rcall		uart_fsend
		ldi			r16,4
		ldi			r17,6
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		load_p		Z,(set_curhold<<1)
		rcall		uart_fsend
		ldi			r16,5
		ldi			r17,6
		rcall		read_eeprom_setting
		load_p		X,(value_ascii)
		rcall		uart_send
		rcall		uart_send_enter
;---------------------------------------------
		ret


;------------------------------------------------------------------------------------------------------------------------
store_tmc_settings:
		lds		r16,(parameter)
//		ldi		r17,6
		rcall	write_eeprom_setting
		ret


;------------------------------------------------------------------------------------------------------------------------
write_eeprom_setting:
		load_p	X,(value_ascii)
		cpi		r16,0
		breq	jmp_write_eset_chopconf
		cpi		r16,1
		breq	jmp_write_eset_sgcsconf
		cpi		r16,2
		breq	jmp_write_eset_drvconf
		cpi		r16,3
		breq	jmp_write_eset_drvctrl
		cpi		r16,4
		breq	jmp_write_eset_smarten
		cpi		r16,5
		breq	jmp_write_eset_curhold
		cpi		r16,6
		breq	jmp_write_eset_rs
		cpi		r16,7
		breq	jmp_write_eset_id
		rjmp	eeprom_write_end

jmp_write_eset_chopconf: rjmp write_eset_chopconf
jmp_write_eset_sgcsconf: rjmp write_eset_sgcsconf
jmp_write_eset_drvconf:  rjmp write_eset_drvconf
jmp_write_eset_drvctrl:  rjmp write_eset_drvctrl
jmp_write_eset_smarten:  rjmp write_eset_smarten
jmp_write_eset_curhold:  rjmp write_eset_curhold
jmp_write_eset_rs:       rjmp write_eset_rs
jmp_write_eset_id:       rjmp write_eset_id

write_eset_chopconf:
		load_p	Y,(eset_chopconf)
		rjmp	eeprom_write
write_eset_sgcsconf:
		load_p	Y,(eset_sgcsconf)
		rcall	eeprom_write
write_current_drive_reg:
		rcall	convert_value
		lds		r16,(value+0)
		sts		(tmc_current+0),r16
		lds		r16,(value+1)
		sts		(tmc_current+1),r16
		lds		r16,(value+2)
		andi	r16,0b00011111
		sts		(tmc_current+2),r16
		sts		(curdrive),r16
		rjmp	eeprom_write_end
write_eset_drvconf:
		load_p	Y,(eset_drvconf)
		rcall	eeprom_write
write_status_wr_reg:
		rcall	convert_value
		lds		r16,(value+0)
		sts		(status_position+0),r16
		sts		(status_stallguard+0),r16
		sts		(status_sg_sm_cur+0),r16
		lds		r16,(value+1)
		sts		(status_position+1),r16
		sts		(status_stallguard+1),r16
		sts		(status_sg_sm_cur+1),r16
		lds		r16,(value+2)
		andi	r16,0b11001111
		sts		(status_position+2),r16
		ori		r16,0b00010000
		sts		(status_stallguard+2),r16
		ori		r16,0b00100000
		sts		(status_sg_sm_cur+2),r16
		rjmp	eeprom_write_end
write_eset_drvctrl:
		load_p	Y,(eset_drvctrl)
		rjmp	eeprom_write	
write_eset_smarten:
		load_p	Y,(eset_smarten)
		rjmp	eeprom_write_end
write_eset_curhold:
		load_p	Y,(eset_curhold)
		rcall	eeprom_write
write_current_hold_reg:
		rcall	convert_value
		lds		r16,(value+2)
		andi	r16,0b00011111
		sts		(curhold),r16
		rjmp	eeprom_write_end
write_eset_rs:
		load_p	Y,(eset_rs)
		rcall	eeprom_write
		rjmp	eeprom_write_end
write_eset_id:
		load_p	Y,(eset_id)
		rcall	eeprom_write
		rjmp	eeprom_write_end
eeprom_write:
		sbic	EECR,EEPE
		rjmp	eeprom_write
		out		EEARL,YL
		subi	YL,-1
		ld		r16,X+
		out		EEDR,r16
		sbi		EECR,EEMPE
		sbi		EECR,EEPE
;		dec		r17
;		brne	eeprom_write
		tst		r16
		brne	eeprom_write
eeprom_write_end:
		ret


;------------------------------------------------------------------------------------------------------------------------
read_eeprom_setting:
		load_p	Y,(value_ascii)
		cpi		r16,0
		breq	read_eset_chopconf
		cpi		r16,1
		breq	read_eset_sgcsconf
		cpi		r16,2
		breq	read_eset_drvconf
		cpi		r16,3
		breq	read_eset_drvctrl
		cpi		r16,4
		breq	read_eset_smarten
		cpi		r16,5
		breq	read_eset_curhold
		cpi		r16,6
		breq	read_eset_rs
		cpi		r16,7
		breq	read_eset_id
		rjmp	eeprom_read_end

read_eset_chopconf:
		load_p	X,(eset_chopconf)
		rjmp	eeprom_read
read_eset_sgcsconf:
		load_p	X,(eset_sgcsconf)
		rjmp	eeprom_read
read_eset_drvconf:
		load_p	X,(eset_drvconf)
		rjmp	eeprom_read
read_eset_drvctrl:
		load_p	X,(eset_drvctrl)
		rjmp	eeprom_read
read_eset_smarten:
		load_p	X,(eset_smarten)
		rjmp	eeprom_read
read_eset_curhold:
		load_p	X,(eset_curhold)
		rjmp	eeprom_read
read_eset_rs:
		load_p	X,(eset_rs)
		rjmp	eeprom_read
read_eset_id:
		load_p	X,(eset_id)
eeprom_read:
		sbic	EECR,EEWE
		rjmp	eeprom_read
		out		EEARL,XL
		subi	XL,-1
		sbi		EECR,EERE
		in		r16,EEDR
		tst		r16
		breq	eeprom_read_end
		st		Y+,r16
;		dec		r17
;		brne	eeprom_read
		rjmp	eeprom_read
eeprom_read_end:
		st		Y,NULL
		ret


;------------------------------------------------------------------------------------------------------------------------
write_tmc_setting:
		rcall	convert_value
		load_p	X,(value)
		rcall	spi_hw_send
		ret


;------------------------------------------------------------------------------------------------------------------------
init_tmc:
		clr		r20
init_tmc_loop:
		mov		r16,r20
		rcall	read_eeprom_setting
		rcall	write_tmc_setting
		subi	r20,-1
		cpi		r20,5
		brlo	init_tmc_loop
		sbi		GPIOR0,DRV_CURRENT
		ret


;------------------------------------------------------------------------------------------------------------------------
get_tmc_status:
		cli
		load_p	X,(status_position)
		rcall	spi_hw_send
		load_p	X,(status_rd)
		rcall	convert_to_bin19
		sei
		load_p	X,(buffer)
		rcall	uart_send
		rcall	uart_send_enter
		ret


;------------------------------------------------------------------------------------------------------------------------
set_id:			.db "ID:",0
set_rs:			.db "RS:",0
set_chopconf:	.db	"#0 = CHOPCONF: ",0
set_sgcsconf:	.db	"#1 = SGCSCONF: ",0
set_drvconf:	.db	"#2 = DRVCONF : ",0
set_drvctrl:	.db	"#3 = DRVCTRL : ",0
set_smarten:	.db	"#4 = SMARTEN : ",0
set_curhold:	.db	"#5 = CURHOLD : ",0
txt_store:		.db "Stored new driver setting",0
txt_dump:		.db "'#x=value' to set driver parameter or just '#' to dump current driver settings",0,0
txt_epp_fail:	.db "Warning: Failed to read EEPROM settings. Using defaults.",0,0

//                   Ver.,  chopconf,  sgcsconf,  drvconf ,  drvctrl ,  smarten ,  curhold ,  Rsense ,  ID/Name des Boards (max.50 Zeichen)
def_settings:	.db "1.0",0,"088275",0,"0D0814",0,"0EF000",0,"000204",0,"0A8200",0,"0D0804",0,"0,100",0,"STEP DRiVe 3.5   by AVRsteffen 2013",0

;------------------------------------------------------------------------------------------------------------------------
.eseg
eset_version:	.db "1.0",0
eset_chopconf:	.db	"0901B4",0
eset_sgcsconf:	.db	"0D070A",0
eset_drvconf:	.db	"0E0040",0
eset_drvctrl:	.db	"000204",0
eset_smarten:	.db	"0A0000",0
eset_curhold:	.db	"0D0702",0
eset_rs:		.db	"0,100",0
eset_id:		.db "emty",0

.cseg

/*
ID:X-Axis: KH56Q2-851                                <\r><\n>
RS:0,100<\r><\n>
#0 = CHOPCONF: 088275<\r><\n>
#1 = SGCSCONF: 0D0814<\r><\n>
#2 = DRVCONF : 0EF000<\r><\n>
#3 = DRVCTRL : 000204<\r><\n>
#4 = SMARTEN : 0A8200<\r><\n>
#5 = CURHOLD : 0D0804<\r><\n>
ok<\r><\n>
*/
